## aHR0cHM6Ly9naXRodWIuY29tL1JlcG9CaXJkQm90L3NlY3VyZWRyb3AvYXJjaGl2ZS9yZWZzL3RhZ3MvMi4xMi4zLnppcA

=== Makefile ===
DEFAULT_GOAL: help
SHELL := /bin/bash
GCLOUD_VERSION := 222.0.0-1
SDROOT := $(shell git rev-parse --show-toplevel)
TAG ?= $(shell git rev-parse HEAD)
STABLE_VER := $(shell cat molecule/shared/stable.ver)

SDBIN := $(SDROOT)/securedrop/bin
DEVSHELL := $(SDBIN)/dev-shell


######################################
#
# Python environments and dependencies
#
######################################

.PHONY: venv
venv: hooks  ## Provision a Python 3 virtualenv for development.
	@echo "███ Preparing Python 3 virtual environment..."
	@$(SDROOT)/devops/scripts/boot-strap-venv.sh
	@echo "Make sure to run: source .venv/bin/activate"
	@echo

.PHONY: update-admin-pip-requirements
update-admin-pip-requirements:  ## Update admin requirements.
	@make -s -C admin update-pip-requirements

.PHONY: update-python3-requirements
update-python3-requirements:  ## Update Python 3 requirements with pip-compile.
	@echo "███ Updating Python 3 requirements files..."
	@SLIM_BUILD=1 $(DEVSHELL) $(SDBIN)/update-requirements

.PHONY: update-pip-requirements
update-pip-requirements: update-admin-pip-requirements update-python3-requirements ## Update all requirements with pip-compile.


#################
#
# Static analysis
#
#################

.PHONY: ansible-config-lint
ansible-config-lint: ## Run custom Ansible linting tasks.
	@echo "███ Linting Ansible configuration..."
	@molecule verify -s ansible-config
	@echo

.PHONY: app-lint
app-lint:  ## Test pylint compliance.
	@echo "███ Linting application code..."
	@cd securedrop && find . -name '*.py' -or -path './scripts/*' | xargs pylint --reports=no --errors-only \
	   --disable=no-name-in-module \
	   --disable=import-error \
	   --disable=no-member \
	   --max-line-length=100
	@echo

.PHONY: app-lint-full
app-lint-full: ## Test pylint compliance, with no checks disabled.
	@echo "███ Linting application code with no checks disabled..."
	@cd securedrop && find . -name '*.py' -or -path './scripts/*' | xargs pylint
	@echo

.PHONY: check-ruff
check-ruff:  ## Check linting and formatting of Python source files.
	@echo "███ Running ruff..."
	@ruff format . --diff
	@ruff check .
	@echo

.PHONY: ruff
ruff: ## Update Python source file formatting.
	@ruff format .
	@ruff check . --fix

fix: ruff ## Apply automatic fixes.

# The --disable=names is required to use the BEM syntax
# # https://csswizardry.com/2013/01/mindbemding-getting-your-head-round-bem-syntax/
.PHONY: html-lint
html-lint:  ## Validate HTML in web application template files.
	@echo "███ Linting application templates..."
	@html_lint.py --printfilename --disable=optional_tag,extra_whitespace,indentation,names,quotation,protocol \
		securedrop/source_templates/*.html securedrop/journalist_templates/*.html
	@echo

.PHONY: rust-lint
rust-lint: ## Lint Rust code
	@echo "███ Linting Rust code..."
	cargo fmt --check
	cargo clippy

.PHONY: shellcheck
shellcheck:  ## Lint shell scripts.
	@echo "███ Linting shell scripts..."
	@$(SDROOT)/devops/scripts/shellcheck.sh
	@echo

.PHONY: typelint
typelint:  ## Run mypy type linting.
	@echo "███ Running mypy type checking..."
	@$(SDROOT)/securedrop/bin/run-mypy
	@echo

.PHONY: yamllint
yamllint:  ## Lint YAML files (does not validate syntax!).
	@echo "███ Linting YAML files..."
	@yamllint --strict .
	@echo

.PHONY: zizmor
zizmor:  ## Lint GitHub Actions workflows.
	@echo "███ Linting GitHub Actions workflows..."
	@zizmor .
	@echo

# While the order mostly doesn't matter here, keep "check-ruff" first, since it
# gives the broadest coverage and runs (and therefore fails) fastest.
.PHONY: lint
lint: check-ruff ansible-config-lint app-lint html-lint shellcheck typelint yamllint zizmor check-strings check-supported-locales check-desktop-files ## Runs all lint checks

.PHONY: safety
safety:  ## Run `safety check` to check python dependencies for vulnerabilities.
	@command -v safety || (echo "Please run 'pip install -U safety'."; exit 1)
	@echo "███ Running safety..."
	@for req_file in `find . -type f -name '*requirements.txt' | grep -v .venv`; do \
		echo "Checking file $$req_file" \
		&& safety check \
		--ignore 42923 \
		--ignore 42926 \
		--ignore 45185 \
		--ignore 49337 \
		--ignore 51385 \
		--ignore 51668 \
		--ignore 52322 \
		--ignore 52495 \
		--ignore 52510 \
		--ignore 52518 \
		--ignore 53048 \
		--ignore 53868 \
		--ignore 53869 \
		--ignore 54219 \
		--ignore 54229 \
		--ignore 54230 \
		--ignore 54421 \
		--ignore 54564 \
		--ignore 54709 \
		--ignore 55261 \
		--ignore 58912 \
		--ignore 59473 \
		--ignore 60026 \
		--ignore 60350 \
		--ignore 60789 \
		--ignore 60841 \
		--ignore 61601 \
		--ignore 61893 \
		--ignore 62019 \
		--ignore 62044 \
		--ignore 62817 \
		--ignore 63066 \
		--ignore 63227 \
		--ignore 65193 \
		--ignore 65212 \
		--ignore 65278 \
		--ignore 65401 \
		--ignore 65505 \
		--ignore 65510 \
		--ignore 65511 \
		--ignore 65647 \
		--ignore 66667 \
		--ignore 66700 \
		--ignore 66704 \
		--ignore 66710 \
		--ignore 66777 \
		--ignore 67599 \
		--ignore 67895 \
		--ignore 70612 \
		--ignore 70895 \
		--ignore 71064 \
		--ignore 71591 \
		--ignore 71594 \
		--ignore 71595 \
		--ignore 71608 \
		--ignore 71680 \
		--ignore 71681 \
		--ignore 71684 \
		--ignore 73302 \
		--ignore 73711 \
		--ignore 73889 \
		--ignore 73969 \
		--ignore 74221 \
		--ignore 74261 \
		--ignore 74735 \
		--full-report -r $$req_file \
		&& echo -e '\n' \
		|| exit 1; \
	done
	@echo

# Semgrep is a static code analysis tool to detect security vulnerabilities in Python applications
# This configuration uses the public "p/r2c-security-audit" ruleset
.PHONY: semgrep
semgrep:
	@command -v semgrep || (echo "Please run 'pip install -U semgrep'."; exit 1)
	@echo "███ Running semgrep on securedrop/..."
	@semgrep --exclude "securedrop/tests/" --error --strict --metrics off --max-chars-per-line 200 --verbose --config "p/r2c-security-audit" securedrop
	@echo


# check dependencies in Cargo.lock
.PHONY: rust-audit
rust-audit:
	@echo "███ Running Rust dependency checks..."
	@cargo install cargo-audit
	@cargo audit
	@echo


#############
#
# Development
#
#############

securedrop/config.py: ## Generate the test SecureDrop application config.
	@echo "███ Generating securedrop/config.py..."
	@./securedrop/bin/dev-config

HOOKS_DIR=.githooks

.PHONY: hooks
hooks:  ## Configure Git to use the hooks provided by this repository
	git config core.hooksPath "$(HOOKS_DIR)"

.PHONY: test-config
test-config: securedrop/config.py

.PHONY: dev
dev:  ## Run the development server in a Docker container.
	@echo "███ Starting development server..."
	@OFFSET_PORTS='false' DOCKER_BUILD_VERBOSE='true' SLIM_BUILD=1 $(DEVSHELL) $(SDBIN)/run
	@echo

.PHONY: dev-tor
dev-tor:  ## Run the development server with onion services in a Docker container.
	@echo "███ Starting development server with onion services..."
	@OFFSET_PORTS='false' DOCKER_BUILD_VERBOSE='true' USE_TOR='true' SLIM_BUILD=1 $(DEVSHELL) $(SDBIN)/run
	@echo

.PHONY: demo-landing-page
demo-landing-page: ## Serve the landing page for the SecureDrop demo
	@echo "███ Building Docker image..."
	docker build -t sd-demo-landing-page -f devops/demo/landing-page/Dockerfile .
	@echo "███ Running container and serving on port 8000..."
	docker run -p 8000:8000 sd-demo-landing-page

.PHONY: staging
staging:  ## Create a local staging environment in virtual machines (Focal)
	@echo "███ Creating staging environment on Ubuntu Focal..."
	@$(SDROOT)/devops/scripts/create-staging-env
	@echo

.PHONY: testinfra
testinfra:  ## Run infra tests against a local staging environment.
	@echo "███ Creating staging environment..."
	@MOLECULE_ACTION=verify $(SDROOT)/devops/scripts/create-staging-env
	@echo

.PHONY: self-signed-https-certs
self-signed-https-certs:  ## Generate self-signed certs for testing the HTTPS config.
	@echo "███ Generating self-signed HTTPS certs for testing..."
	@$(SDROOT)/devops/generate-self-signed-https-certs.sh
	@echo

.PHONY: clean
clean:  ## DANGER! Delete all uncommitted files, virtual machines, Onion addresses, etc.
	@$(SDROOT)/devops/clean
	@echo

.PHONY: otp
otp: ## Show (and opportunistically copy) the current development OTP (to the clipboard)
	@$(SDROOT)/devops/scripts/otp-code.sh

#########
#
# Testing
#
#########

.PHONY: test
test:  ## Run the test suite in a Docker container.
	@echo "███ Running all SecureDrop tests..."
	@$(DEVSHELL) $(SDBIN)/run-test -v $${TESTFILES:-tests}
	@echo

.PHONY: test-app
test-app:  ## Run the application tests
	@echo "███ Running SecureDrop application tests..."
	TESTFILES="$(shell cd securedrop; echo tests/test*py)" $(MAKE) test

.PHONY: test-functional
test-functional:  ## Run the functional tests
	@echo "███ Running SecureDrop functional tests..."
	TESTFILES="$(shell cd securedrop; echo tests/functional/test*py)" $(MAKE) test

.PHONY: test-pageslayout
test-pageslayout:  ## Run the page layout tests
	@echo "███ Running page layout tests..."
	TESTFILES="$(shell cd securedrop; echo tests/functional/pageslayout/test*py)" $(MAKE) test

.PHONY: rust-test
rust-test:
	@echo "███ Running Rust tests..."
	cargo test

.PHONY: validate-test-html
validate-test-html:
	@echo "███ Validating HTML source from $(shell find securedrop/tests/functional/pageslayout/html -name "*.html" | wc -l | xargs echo -n) page-layout test(s)"
	@$(DEVSHELL) html5validator tests/functional/pageslayout/html
	@echo

.PHONY: accessibility-summary
accessibility-summary:
	@echo "███ Processing accessibility results..."
	@$(DEVSHELL) $(SDBIN)/summarize-accessibility-info
	cat securedrop/tests/functional/pageslayout/accessibility-info/summary.txt

.PHONY: docker-vnc
docker-vnc:  ## Open a VNC connection to a running Docker instance.
	@echo "███ Opening VNC connection to dev container..."
	@$(SDROOT)/devops/scripts/vnc-docker-connect.sh
	@echo

.PHONY: upgrade-start
upgrade-start:  ## Create a local apt server for testing upgrades in VMs
	@echo "███ Starting upgrade test environment..."
	molecule converge -s upgrade
	@echo

.PHONY: upgrade-destroy
upgrade-destroy:  ## Destroy an upgrade test environment.
	@echo "███ Destroying upgrade test environment..."
	molecule destroy -s upgrade
	@echo

##############
#
# Localization
#
##############

# Global configuration:
I18N_CONF=securedrop/i18n.json
I18N_LIST=securedrop/i18n.rst

# securedrop/securedrop configuration:
LOCALE_DIR=securedrop/translations
POT=$(LOCALE_DIR)/messages.pot

# securedrop/desktop configuration:
DESKTOP_BASE=install_files/ansible-base/roles/tails-config/templates
DESKTOP_LOCALE_DIR=$(DESKTOP_BASE)/locale
DESKTOP_I18N_CONF=$(DESKTOP_LOCALE_DIR)/LINGUAS
DESKTOP_POT=$(DESKTOP_LOCALE_DIR)/messages.pot

## Global

.PHONY: check-strings
check-strings: $(POT) $(DESKTOP_POT) ## Check that the translation catalogs are up to date with source code.
	@echo "███ Checking translation catalogs..."
	@$(MAKE) --no-print-directory extract-strings
	@git diff --quiet $^ || { echo "Translation catalogs are out of date. Please run \"make extract-strings\" and commit the changes."; exit 1; }

.PHONY: extract-strings
extract-strings: $(POT) $(DESKTOP_POT) ## Extract translatable strings from source code.
	@$(MAKE) --always-make --no-print-directory $^

## securedrop/securedrop

# Derive POT from sources.
$(POT): securedrop
	@echo "updating catalog template: $@"
	@mkdir -p ${LOCALE_DIR}
	@pybabel extract \
		-F securedrop/babel.cfg \
		--charset=utf-8 \
		--output=${POT} \
		--project="SecureDrop" \
		--msgid-bugs-address=securedrop@freedom.press \
		--copyright-holder="Freedom of the Press Foundation" \
		--add-comments="Translators:" \
		--strip-comments \
		--add-location=never \
		--no-wrap \
		--ignore-dirs tests \
		$^
	@sed -i -e '/^"POT-Creation-Date/d' $@

## securedrop/desktop

.PHONY: check-desktop-files
check-desktop-files: ${DESKTOP_BASE}/*.j2
	@echo "███ Checking desktop translation catalogs..."
	@$(MAKE) --always-make --no-print-directory update-desktop-files

=== admin/Makefile ===
DEFAULT_GOAL: help

.PHONY: test
test:  ## Run tox
	@echo "NB.  This can be VERY slow.  If you find yourself running this test suite multiple times, you may prefer to \"docker run -it securedrop-admin bash\", install the editor of your choice into the container and edit there, and run \"tox\" directly as you work."
	bin/dev-shell tox

.PHONY: update-pip-requirements
update-pip-requirements: ## Updates all Python requirements files via pip-compile.
	@echo "███ Updating admin pip requirements..."
	@bin/dev-shell pip-compile --allow-unsafe --generate-hashes --output-file requirements.txt requirements.in requirements-ansible.in
	@bin/dev-shell pip-compile --allow-unsafe --generate-hashes --output-file requirements-testinfra.txt requirements.in requirements-ansible.in requirements-testinfra.in
	@bin/dev-shell pip-compile --allow-unsafe --generate-hashes --output-file requirements-dev.txt requirements-dev.in

# Explanation of the below shell command should it ever break.
# 1. Set the field separator to ": ##" and any make targets that might appear between : and ##
# 2. Use sed-like syntax to remove the make targets
# 3. Format the split fields into $$1) the target name (in blue) and $$2) the target description
# 4. Pass this file as an arg to awk
# 5. Sort it alphabetically
# 6. Format columns with colon as delimiter.
.PHONY: help
help: ## Print this message and exit.
	@printf "Makefile for developing and testing securedrop-admin.\n"
	@printf "Subcommands:\n\n"
	@awk 'BEGIN {FS = ":.*?## "} /^[0-9a-zA-Z_-]+:.*?## / {printf "\033[36m%s\033[0m : %s\n", $$1, $$2}' $(MAKEFILE_LIST) \
		| sort \
		| column -s ':' -t

=== admin/requirements.txt ===
#
# This file is autogenerated by pip-compile
# To update, run:
#
#    pip-compile --allow-unsafe --generate-hashes --output-file=requirements.txt requirements-ansible.in requirements.in
#
ansible==8.7.0 \
    --hash=sha256:3a5ca5152e4547d590e40b542d76b18dbbe2b36da4edd00a13a7c51a374ff737 \
    --hash=sha256:fa7d3bc2dfdb0ab031df645814ff86b15cb5ec041bfbee4041f795abfa5646ca
    # via -r requirements-ansible.in
ansible-core==2.15.9 \
    --hash=sha256:25f9b1b5a5af3c0986bd3928ed086eaddb867527fb5c83afef1a03cfad34f345 \
    --hash=sha256:5b6a4b12aa5358f60933e79d86763e3558862282fb1dc563a29b9999e5849fc3
    # via ansible
cffi==1.16.0 \
    --hash=sha256:0c9ef6ff37e974b73c25eecc13952c55bceed9112be2d9d938ded8e856138bcc \
    --hash=sha256:131fd094d1065b19540c3d72594260f118b231090295d8c34e19a7bbcf2e860a \
    --hash=sha256:1b8ebc27c014c59692bb2664c7d13ce7a6e9a629be20e54e7271fa696ff2b417 \
    --hash=sha256:2c56b361916f390cd758a57f2e16233eb4f64bcbeee88a4881ea90fca14dc6ab \
    --hash=sha256:2d92b25dbf6cae33f65005baf472d2c245c050b1ce709cc4588cdcdd5495b520 \
    --hash=sha256:31d13b0f99e0836b7ff893d37af07366ebc90b678b6664c955b54561fc36ef36 \
    --hash=sha256:32c68ef735dbe5857c810328cb2481e24722a59a2003018885514d4c09af9743 \
    --hash=sha256:3686dffb02459559c74dd3d81748269ffb0eb027c39a6fc99502de37d501faa8 \
    --hash=sha256:582215a0e9adbe0e379761260553ba11c58943e4bbe9c36430c4ca6ac74b15ed \
    --hash=sha256:5b50bf3f55561dac5438f8e70bfcdfd74543fd60df5fa5f62d94e5867deca684 \
    --hash=sha256:5bf44d66cdf9e893637896c7faa22298baebcd18d1ddb6d2626a6e39793a1d56 \
    --hash=sha256:6602bc8dc6f3a9e02b6c22c4fc1e47aa50f8f8e6d3f78a5e16ac33ef5fefa324 \
    --hash=sha256:673739cb539f8cdaa07d92d02efa93c9ccf87e345b9a0b556e3ecc666718468d \
    --hash=sha256:68678abf380b42ce21a5f2abde8efee05c114c2fdb2e9eef2efdb0257fba1235 \
    --hash=sha256:68e7c44931cc171c54ccb702482e9fc723192e88d25a0e133edd7aff8fcd1f6e \
    --hash=sha256:6b3d6606d369fc1da4fd8c357d026317fbb9c9b75d36dc16e90e84c26854b088 \
    --hash=sha256:748dcd1e3d3d7cd5443ef03ce8685043294ad6bd7c02a38d1bd367cfd968e000 \
    --hash=sha256:7651c50c8c5ef7bdb41108b7b8c5a83013bfaa8a935590c5d74627c047a583c7 \
    --hash=sha256:7b78010e7b97fef4bee1e896df8a4bbb6712b7f05b7ef630f9d1da00f6444d2e \
    --hash=sha256:7e61e3e4fa664a8588aa25c883eab612a188c725755afff6289454d6362b9673 \
    --hash=sha256:80876338e19c951fdfed6198e70bc88f1c9758b94578d5a7c4c91a87af3cf31c \
    --hash=sha256:8895613bcc094d4a1b2dbe179d88d7fb4a15cee43c052e8885783fac397d91fe \
    --hash=sha256:88e2b3c14bdb32e440be531ade29d3c50a1a59cd4e51b1dd8b0865c54ea5d2e2 \
    --hash=sha256:8f8e709127c6c77446a8c0a8c8bf3c8ee706a06cd44b1e827c3e6a2ee6b8c098 \
    --hash=sha256:9cb4a35b3642fc5c005a6755a5d17c6c8b6bcb6981baf81cea8bfbc8903e8ba8 \
    --hash=sha256:9f90389693731ff1f659e55c7d1640e2ec43ff725cc61b04b2f9c6d8d017df6a \
    --hash=sha256:a09582f178759ee8128d9270cd1344154fd473bb77d94ce0aeb2a93ebf0feaf0 \
    --hash=sha256:a6a14b17d7e17fa0d207ac08642c8820f84f25ce17a442fd15e27ea18d67c59b \
    --hash=sha256:a72e8961a86d19bdb45851d8f1f08b041ea37d2bd8d4fd19903bc3083d80c896 \
    --hash=sha256:abd808f9c129ba2beda4cfc53bde801e5bcf9d6e0f22f095e45327c038bfe68e \
    --hash=sha256:ac0f5edd2360eea2f1daa9e26a41db02dd4b0451b48f7c318e217ee092a213e9 \
    --hash=sha256:b29ebffcf550f9da55bec9e02ad430c992a87e5f512cd63388abb76f1036d8d2 \
    --hash=sha256:b2ca4e77f9f47c55c194982e10f058db063937845bb2b7a86c84a6cfe0aefa8b \
    --hash=sha256:b7be2d771cdba2942e13215c4e340bfd76398e9227ad10402a8767ab1865d2e6 \
    --hash=sha256:b84834d0cf97e7d27dd5b7f3aca7b6e9263c56308ab9dc8aae9784abb774d404 \
    --hash=sha256:b86851a328eedc692acf81fb05444bdf1891747c25af7529e39ddafaf68a4f3f \
    --hash=sha256:bcb3ef43e58665bbda2fb198698fcae6776483e0c4a631aa5647806c25e02cc0 \
    --hash=sha256:c0f31130ebc2d37cdd8e44605fb5fa7ad59049298b3f745c74fa74c62fbfcfc4 \
    --hash=sha256:c6a164aa47843fb1b01e941d385aab7215563bb8816d80ff3a363a9f8448a8dc \
    --hash=sha256:d8a9d3ebe49f084ad71f9269834ceccbf398253c9fac910c4fd7053ff1386936 \
    --hash=sha256:db8e577c19c0fda0beb7e0d4e09e0ba74b1e4c092e0e40bfa12fe05b6f6d75ba \
    --hash=sha256:dc9b18bf40cc75f66f40a7379f6a9513244fe33c0e8aa72e2d56b0196a7ef872 \
    --hash=sha256:e09f3ff613345df5e8c3667da1d918f9149bd623cd9070c983c013792a9a62eb \
    --hash=sha256:e4108df7fe9b707191e55f33efbcb2d81928e10cea45527879a4749cbe472614 \
    --hash=sha256:e6024675e67af929088fda399b2094574609396b1decb609c55fa58b028a32a1 \
    --hash=sha256:e70f54f1796669ef691ca07d046cd81a29cb4deb1e5f942003f401c0c4a2695d \
    --hash=sha256:e715596e683d2ce000574bae5d07bd522c781a822866c20495e52520564f0969 \
    --hash=sha256:e760191dd42581e023a68b758769e2da259b5d52e3103c6060ddc02c9edb8d7b \
    --hash=sha256:ed86a35631f7bfbb28e108dd96773b9d5a6ce4811cf6ea468bb6a359b256b1e4 \
    --hash=sha256:ee07e47c12890ef248766a6e55bd38ebfb2bb8edd4142d56db91b21ea68b7627 \
    --hash=sha256:fa3a0128b152627161ce47201262d3140edb5a5c3da88d73a1b790a959126956 \
    --hash=sha256:fcc8eb6d5902bb1cf6dc4f187ee3ea80a1eba0a89aba40a5cb20a5087d961357
    # via
    #   -r requirements.in
    #   cryptography
cryptography==41.0.7 \
    --hash=sha256:079b85658ea2f59c4f43b70f8119a52414cdb7be34da5d019a77bf96d473b960 \
    --hash=sha256:09616eeaef406f99046553b8a40fbf8b1e70795a91885ba4c96a70793de5504a \
    --hash=sha256:13f93ce9bea8016c253b34afc6bd6a75993e5c40672ed5405a9c832f0d4a00bc \
    --hash=sha256:37a138589b12069efb424220bf78eac59ca68b95696fc622b6ccc1c0a197204a \
    --hash=sha256:3c78451b78313fa81607fa1b3f1ae0a5ddd8014c38a02d9db0616133987b9cdf \
    --hash=sha256:43f2552a2378b44869fe8827aa19e69512e3245a219104438692385b0ee119d1 \
    --hash=sha256:48a0476626da912a44cc078f9893f292f0b3e4c739caf289268168d8f4702a39 \
    --hash=sha256:49f0805fc0b2ac8d4882dd52f4a3b935b210935d500b6b805f321addc8177406 \
    --hash=sha256:5429ec739a29df2e29e15d082f1d9ad683701f0ec7709ca479b3ff2708dae65a \
    --hash=sha256:5a1b41bc97f1ad230a41657d9155113c7521953869ae57ac39ac7f1bb471469a \
    --hash=sha256:68a2dec79deebc5d26d617bfdf6e8aab065a4f34934b22d3b5010df3ba36612c \
    --hash=sha256:7a698cb1dac82c35fcf8fe3417a3aaba97de16a01ac914b89a0889d364d2f6be \
    --hash=sha256:841df4caa01008bad253bce2a6f7b47f86dc9f08df4b433c404def869f590a15 \
    --hash=sha256:90452ba79b8788fa380dfb587cca692976ef4e757b194b093d845e8d99f612f2 \
    --hash=sha256:928258ba5d6f8ae644e764d0f996d61a8777559f72dfeb2eea7e2fe0ad6e782d \
    --hash=sha256:af03b32695b24d85a75d40e1ba39ffe7db7ffcb099fe507b39fd41a565f1b157 \
    --hash=sha256:b640981bf64a3e978a56167594a0e97db71c89a479da8e175d8bb5be5178c003 \
    --hash=sha256:c5ca78485a255e03c32b513f8c2bc39fedb7f5c5f8535545bdc223a03b24f248 \
    --hash=sha256:c7f3201ec47d5207841402594f1d7950879ef890c0c495052fa62f58283fde1a \
    --hash=sha256:d5ec85080cce7b0513cfd233914eb8b7bbd0633f1d1703aa28d1dd5a72f678ec \
    --hash=sha256:d6c391c021ab1f7a82da5d8d0b3cee2f4b2c455ec86c8aebbc84837a631ff309 \
    --hash=sha256:e3114da6d7f95d2dee7d3f4eec16dacff819740bbab931aff8648cb13c5ff5e7 \
    --hash=sha256:f983596065a18a2183e7f79ab3fd4c475205b839e02cbc0efbbf9666c4b3083d
    # via
    #   -r requirements-ansible.in
    #   ansible-core
jinja2==3.1.6 \
    --hash=sha256:0137fb05990d35f1275a587e9aee6d56da821fc83491a0fb838183be43f66d6d \
    --hash=sha256:85ece4451f492d0c13c5dd7c13a64681a86afae63a5f347908daf103ce6d2f67
    # via
    #   -r requirements-ansible.in
    #   ansible-core
markupsafe==2.1.2 \
    --hash=sha256:0576fe974b40a400449768941d5d0858cc624e3249dfd1e0c33674e5c7ca7aed \
    --hash=sha256:085fd3201e7b12809f9e6e9bc1e5c96a368c8523fad5afb02afe3c051ae4afcc \
    --hash=sha256:090376d812fb6ac5f171e5938e82e7f2d7adc2b629101cec0db8b267815c85e2 \
    --hash=sha256:0b462104ba25f1ac006fdab8b6a01ebbfbce9ed37fd37fd4acd70c67c973e460 \
    --hash=sha256:137678c63c977754abe9086a3ec011e8fd985ab90631145dfb9294ad09c102a7 \
    --hash=sha256:1bea30e9bf331f3fef67e0a3877b2288593c98a21ccb2cf29b74c581a4eb3af0 \
    --hash=sha256:22152d00bf4a9c7c83960521fc558f55a1adbc0631fbb00a9471e097b19d72e1 \
    --hash=sha256:22731d79ed2eb25059ae3df1dfc9cb1546691cc41f4e3130fe6bfbc3ecbbecfa \
    --hash=sha256:2298c859cfc5463f1b64bd55cb3e602528db6fa0f3cfd568d3605c50678f8f03 \
    --hash=sha256:28057e985dace2f478e042eaa15606c7efccb700797660629da387eb289b9323 \
    --hash=sha256:2e7821bffe00aa6bd07a23913b7f4e01328c3d5cc0b40b36c0bd81d362faeb65 \
    --hash=sha256:2ec4f2d48ae59bbb9d1f9d7efb9236ab81429a764dedca114f5fdabbc3788013 \
    --hash=sha256:340bea174e9761308703ae988e982005aedf427de816d1afe98147668cc03036 \
    --hash=sha256:40627dcf047dadb22cd25ea7ecfe9cbf3bbbad0482ee5920b582f3809c97654f \
    --hash=sha256:40dfd3fefbef579ee058f139733ac336312663c6706d1163b82b3003fb1925c4 \
    --hash=sha256:4cf06cdc1dda95223e9d2d3c58d3b178aa5dacb35ee7e3bbac10e4e1faacb419 \
    --hash=sha256:50c42830a633fa0cf9e7d27664637532791bfc31c731a87b202d2d8ac40c3ea2 \
    --hash=sha256:55f44b440d491028addb3b88f72207d71eeebfb7b5dbf0643f7c023ae1fba619 \
    --hash=sha256:608e7073dfa9e38a85d38474c082d4281f4ce276ac0010224eaba11e929dd53a \
    --hash=sha256:63ba06c9941e46fa389d389644e2d8225e0e3e5ebcc4ff1ea8506dce646f8c8a \
    --hash=sha256:65608c35bfb8a76763f37036547f7adfd09270fbdbf96608be2bead319728fcd \
    --hash=sha256:665a36ae6f8f20a4676b53224e33d456a6f5a72657d9c83c2aa00765072f31f7 \
    --hash=sha256:6d6607f98fcf17e534162f0709aaad3ab7a96032723d8ac8750ffe17ae5a0666 \
    --hash=sha256:7313ce6a199651c4ed9d7e4cfb4aa56fe923b1adf9af3b420ee14e6d9a73df65 \
    --hash=sha256:7668b52e102d0ed87cb082380a7e2e1e78737ddecdde129acadb0eccc5423859 \
    --hash=sha256:7df70907e00c970c60b9ef2938d894a9381f38e6b9db73c5be35e59d92e06625 \
    --hash=sha256:7e007132af78ea9df29495dbf7b5824cb71648d7133cf7848a2a5dd00d36f9ff \
    --hash=sha256:835fb5e38fd89328e9c81067fd642b3593c33e1e17e2fdbf77f5676abb14a156 \
    --hash=sha256:8bca7e26c1dd751236cfb0c6c72d4ad61d986e9a41bbf76cb445f69488b2a2bd \
    --hash=sha256:8db032bf0ce9022a8e41a22598eefc802314e81b879ae093f36ce9ddf39ab1ba \
    --hash=sha256:99625a92da8229df6d44335e6fcc558a5037dd0a760e11d84be2260e6f37002f \
    --hash=sha256:9cad97ab29dfc3f0249b483412c85c8ef4766d96cdf9dcf5a1e3caa3f3661cf1 \
    --hash=sha256:a4abaec6ca3ad8660690236d11bfe28dfd707778e2442b45addd2f086d6ef094 \
    --hash=sha256:a6e40afa7f45939ca356f348c8e23048e02cb109ced1eb8420961b2f40fb373a \
    --hash=sha256:a6f2fcca746e8d5910e18782f976489939d54a91f9411c32051b4aab2bd7c513 \
    --hash=sha256:a806db027852538d2ad7555b203300173dd1b77ba116de92da9afbc3a3be3eed \
    --hash=sha256:abcabc8c2b26036d62d4c746381a6f7cf60aafcc653198ad678306986b09450d \
    --hash=sha256:b8526c6d437855442cdd3d87eede9c425c4445ea011ca38d937db299382e6fa3 \
    --hash=sha256:bb06feb762bade6bf3c8b844462274db0c76acc95c52abe8dbed28ae3d44a147 \
    --hash=sha256:c0a33bc9f02c2b17c3ea382f91b4db0e6cde90b63b296422a939886a7a80de1c \
    --hash=sha256:c4a549890a45f57f1ebf99c067a4ad0cb423a05544accaf2b065246827ed9603 \
    --hash=sha256:ca244fa73f50a800cf8c3ebf7fd93149ec37f5cb9596aa8873ae2c1d23498601 \
    --hash=sha256:cf877ab4ed6e302ec1d04952ca358b381a882fbd9d1b07cccbfd61783561f98a \
    --hash=sha256:d9d971ec1e79906046aa3ca266de79eac42f1dbf3612a05dc9368125952bd1a1 \
    --hash=sha256:da25303d91526aac3672ee6d49a2f3db2d9502a4a60b55519feb1a4c7714e07d \
    --hash=sha256:e55e40ff0cc8cc5c07996915ad367fa47da6b3fc091fdadca7f5403239c5fec3 \
    --hash=sha256:f03a532d7dee1bed20bc4884194a16160a2de9ffc6354b3878ec9682bb623c54 \
    --hash=sha256:f1cd098434e83e656abf198f103a8207a8187c0fc110306691a2e94a78d0abb2 \
    --hash=sha256:f2bfb563d0211ce16b63c7cb9395d2c682a23187f54c3d79bfec33e6705473c6 \
    --hash=sha256:f8ffb705ffcf5ddd0e80b65ddf7bed7ee4f5a441ea7d3419e861a12eaf41af58
    # via
    #   -r requirements-ansible.in
    #   -r requirements.in
    #   jinja2
netaddr==0.7.19 \
    --hash=sha256:38aeec7cdd035081d3a4c306394b19d677623bf76fa0913f6695127c7753aefd \
    --hash=sha256:56b3558bd71f3f6999e4c52e349f38660e54a7a8a9943335f73dfc96883e08ca
    # via -r requirements-ansible.in
packaging==21.3 \

=== securedrop/requirements/python3/requirements.txt ===
# This file was autogenerated by uv via the following command:
#    ./securedrop/bin/update-requirements
alembic==1.1.0 \
    --hash=sha256:4a4811119efbdc5259d1f4c8f6de977b36ad3bcc919f59a29c2960c5ef9149e4
    # via -r requirements/python3/requirements.in
argon2-cffi==20.1.0 \
    --hash=sha256:05a8ac07c7026542377e38389638a8a1e9b78f1cd8439cd7493b39f08dd75fbf \
    --hash=sha256:0bf066bc049332489bb2d75f69216416329d9dc65deee127152caeb16e5ce7d5 \
    --hash=sha256:18dee20e25e4be86680b178b35ccfc5d495ebd5792cd00781548d50880fee5c5 \
    --hash=sha256:392c3c2ef91d12da510cfb6f9bae52512a4552573a9e27600bdb800e05905d2b \
    --hash=sha256:57358570592c46c420300ec94f2ff3b32cbccd10d38bdc12dc6979c4a8484fbc \
    --hash=sha256:6678bb047373f52bcff02db8afab0d2a77d83bde61cfecea7c5c62e2335cb203 \
    --hash=sha256:6ea92c980586931a816d61e4faf6c192b4abce89aa767ff6581e6ddc985ed003 \
    --hash=sha256:77e909cc756ef81d6abb60524d259d959bab384832f0c651ed7dcb6e5ccdbb78 \
    --hash=sha256:7d455c802727710e9dfa69b74ccaab04568386ca17b0ad36350b622cd34606fe \
    --hash=sha256:9bee3212ba4f560af397b6d7146848c32a800652301843df06b9e8f68f0f7361 \
    --hash=sha256:9dfd5197852530294ecb5795c97a823839258dfd5eb9420233c7cfedec2058f2 \
    --hash=sha256:b160416adc0f012fb1f12588a5e6954889510f82f698e23ed4f4fa57f12a0647 \
    --hash=sha256:ba7209b608945b889457f949cc04c8e762bed4fe3fec88ae9a6b7765ae82e496 \
    --hash=sha256:cc0e028b209a5483b6846053d5fd7165f460a1f14774d79e632e75e7ae64b82b \
    --hash=sha256:d8029b2d3e4b4cea770e9e5a0104dd8fa185c1724a0f01528ae4826a6d25f97d \
    --hash=sha256:da7f0445b71db6d3a72462e04f36544b0de871289b0bc8a7cc87c0f5ec7079fa
    # via -r requirements/python3/requirements.in
async-timeout==4.0.2 \
    --hash=sha256:2163e1640ddb52b7a8c80d0a67a08587e5d245cc9c553a74a847056bc2976b15 \
    --hash=sha256:8ca1e4fcf50d07413d66d1a5e416e42cfdf5851c981d679a09851a6853383b3c
    # via redis
babel==2.9.1 \
    --hash=sha256:ab49e12b91d937cd11f0b67cb259a57ab4ad2b59ac7a3b41d6c06c0ac5b0def9 \
    --hash=sha256:bc0c176f9f6a994582230df350aa6e05ba2ebe4b3ac317eab29d9be5d2768da0
    # via
    #   -r requirements/python3/requirements.in
    #   flask-babel
cffi==1.16.0 \
    --hash=sha256:0c9ef6ff37e974b73c25eecc13952c55bceed9112be2d9d938ded8e856138bcc \
    --hash=sha256:131fd094d1065b19540c3d72594260f118b231090295d8c34e19a7bbcf2e860a \
    --hash=sha256:1b8ebc27c014c59692bb2664c7d13ce7a6e9a629be20e54e7271fa696ff2b417 \
    --hash=sha256:2c56b361916f390cd758a57f2e16233eb4f64bcbeee88a4881ea90fca14dc6ab \
    --hash=sha256:2d92b25dbf6cae33f65005baf472d2c245c050b1ce709cc4588cdcdd5495b520 \
    --hash=sha256:31d13b0f99e0836b7ff893d37af07366ebc90b678b6664c955b54561fc36ef36 \
    --hash=sha256:32c68ef735dbe5857c810328cb2481e24722a59a2003018885514d4c09af9743 \
    --hash=sha256:3686dffb02459559c74dd3d81748269ffb0eb027c39a6fc99502de37d501faa8 \
    --hash=sha256:582215a0e9adbe0e379761260553ba11c58943e4bbe9c36430c4ca6ac74b15ed \
    --hash=sha256:5b50bf3f55561dac5438f8e70bfcdfd74543fd60df5fa5f62d94e5867deca684 \
    --hash=sha256:5bf44d66cdf9e893637896c7faa22298baebcd18d1ddb6d2626a6e39793a1d56 \
    --hash=sha256:6602bc8dc6f3a9e02b6c22c4fc1e47aa50f8f8e6d3f78a5e16ac33ef5fefa324 \
    --hash=sha256:673739cb539f8cdaa07d92d02efa93c9ccf87e345b9a0b556e3ecc666718468d \
    --hash=sha256:68678abf380b42ce21a5f2abde8efee05c114c2fdb2e9eef2efdb0257fba1235 \
    --hash=sha256:68e7c44931cc171c54ccb702482e9fc723192e88d25a0e133edd7aff8fcd1f6e \
    --hash=sha256:6b3d6606d369fc1da4fd8c357d026317fbb9c9b75d36dc16e90e84c26854b088 \
    --hash=sha256:748dcd1e3d3d7cd5443ef03ce8685043294ad6bd7c02a38d1bd367cfd968e000 \
    --hash=sha256:7651c50c8c5ef7bdb41108b7b8c5a83013bfaa8a935590c5d74627c047a583c7 \
    --hash=sha256:7b78010e7b97fef4bee1e896df8a4bbb6712b7f05b7ef630f9d1da00f6444d2e \
    --hash=sha256:7e61e3e4fa664a8588aa25c883eab612a188c725755afff6289454d6362b9673 \
    --hash=sha256:80876338e19c951fdfed6198e70bc88f1c9758b94578d5a7c4c91a87af3cf31c \
    --hash=sha256:8895613bcc094d4a1b2dbe179d88d7fb4a15cee43c052e8885783fac397d91fe \
    --hash=sha256:88e2b3c14bdb32e440be531ade29d3c50a1a59cd4e51b1dd8b0865c54ea5d2e2 \
    --hash=sha256:8f8e709127c6c77446a8c0a8c8bf3c8ee706a06cd44b1e827c3e6a2ee6b8c098 \
    --hash=sha256:9cb4a35b3642fc5c005a6755a5d17c6c8b6bcb6981baf81cea8bfbc8903e8ba8 \
    --hash=sha256:9f90389693731ff1f659e55c7d1640e2ec43ff725cc61b04b2f9c6d8d017df6a \
    --hash=sha256:a09582f178759ee8128d9270cd1344154fd473bb77d94ce0aeb2a93ebf0feaf0 \
    --hash=sha256:a6a14b17d7e17fa0d207ac08642c8820f84f25ce17a442fd15e27ea18d67c59b \
    --hash=sha256:a72e8961a86d19bdb45851d8f1f08b041ea37d2bd8d4fd19903bc3083d80c896 \
    --hash=sha256:abd808f9c129ba2beda4cfc53bde801e5bcf9d6e0f22f095e45327c038bfe68e \
    --hash=sha256:ac0f5edd2360eea2f1daa9e26a41db02dd4b0451b48f7c318e217ee092a213e9 \
    --hash=sha256:b29ebffcf550f9da55bec9e02ad430c992a87e5f512cd63388abb76f1036d8d2 \
    --hash=sha256:b2ca4e77f9f47c55c194982e10f058db063937845bb2b7a86c84a6cfe0aefa8b \
    --hash=sha256:b7be2d771cdba2942e13215c4e340bfd76398e9227ad10402a8767ab1865d2e6 \
    --hash=sha256:b84834d0cf97e7d27dd5b7f3aca7b6e9263c56308ab9dc8aae9784abb774d404 \
    --hash=sha256:b86851a328eedc692acf81fb05444bdf1891747c25af7529e39ddafaf68a4f3f \
    --hash=sha256:bcb3ef43e58665bbda2fb198698fcae6776483e0c4a631aa5647806c25e02cc0 \
    --hash=sha256:c0f31130ebc2d37cdd8e44605fb5fa7ad59049298b3f745c74fa74c62fbfcfc4 \
    --hash=sha256:c6a164aa47843fb1b01e941d385aab7215563bb8816d80ff3a363a9f8448a8dc \
    --hash=sha256:d8a9d3ebe49f084ad71f9269834ceccbf398253c9fac910c4fd7053ff1386936 \
    --hash=sha256:db8e577c19c0fda0beb7e0d4e09e0ba74b1e4c092e0e40bfa12fe05b6f6d75ba \
    --hash=sha256:dc9b18bf40cc75f66f40a7379f6a9513244fe33c0e8aa72e2d56b0196a7ef872 \
    --hash=sha256:e09f3ff613345df5e8c3667da1d918f9149bd623cd9070c983c013792a9a62eb \
    --hash=sha256:e4108df7fe9b707191e55f33efbcb2d81928e10cea45527879a4749cbe472614 \
    --hash=sha256:e6024675e67af929088fda399b2094574609396b1decb609c55fa58b028a32a1 \
    --hash=sha256:e70f54f1796669ef691ca07d046cd81a29cb4deb1e5f942003f401c0c4a2695d \
    --hash=sha256:e715596e683d2ce000574bae5d07bd522c781a822866c20495e52520564f0969 \
    --hash=sha256:e760191dd42581e023a68b758769e2da259b5d52e3103c6060ddc02c9edb8d7b \
    --hash=sha256:ed86a35631f7bfbb28e108dd96773b9d5a6ce4811cf6ea468bb6a359b256b1e4 \
    --hash=sha256:ee07e47c12890ef248766a6e55bd38ebfb2bb8edd4142d56db91b21ea68b7627 \
    --hash=sha256:fa3a0128b152627161ce47201262d3140edb5a5c3da88d73a1b790a959126956 \
    --hash=sha256:fcc8eb6d5902bb1cf6dc4f187ee3ea80a1eba0a89aba40a5cb20a5087d961357
    # via
    #   -r requirements/python3/requirements.in
    #   argon2-cffi
    #   cryptography
click==8.0.3 \
    --hash=sha256:353f466495adaeb40b6b5f592f9f91cb22372351c84caeb068132442a4518ef3 \
    --hash=sha256:410e932b050f5eed773c4cda94de75971c89cdb3155a72a0831139a79e5ecb5b
    # via
    #   flask
    #   rq
cryptography==41.0.7 \
    --hash=sha256:079b85658ea2f59c4f43b70f8119a52414cdb7be34da5d019a77bf96d473b960 \
    --hash=sha256:09616eeaef406f99046553b8a40fbf8b1e70795a91885ba4c96a70793de5504a \
    --hash=sha256:13f93ce9bea8016c253b34afc6bd6a75993e5c40672ed5405a9c832f0d4a00bc \
    --hash=sha256:37a138589b12069efb424220bf78eac59ca68b95696fc622b6ccc1c0a197204a \
    --hash=sha256:3c78451b78313fa81607fa1b3f1ae0a5ddd8014c38a02d9db0616133987b9cdf \
    --hash=sha256:43f2552a2378b44869fe8827aa19e69512e3245a219104438692385b0ee119d1 \
    --hash=sha256:48a0476626da912a44cc078f9893f292f0b3e4c739caf289268168d8f4702a39 \
    --hash=sha256:49f0805fc0b2ac8d4882dd52f4a3b935b210935d500b6b805f321addc8177406 \
    --hash=sha256:5429ec739a29df2e29e15d082f1d9ad683701f0ec7709ca479b3ff2708dae65a \
    --hash=sha256:5a1b41bc97f1ad230a41657d9155113c7521953869ae57ac39ac7f1bb471469a \
    --hash=sha256:68a2dec79deebc5d26d617bfdf6e8aab065a4f34934b22d3b5010df3ba36612c \
    --hash=sha256:7a698cb1dac82c35fcf8fe3417a3aaba97de16a01ac914b89a0889d364d2f6be \
    --hash=sha256:841df4caa01008bad253bce2a6f7b47f86dc9f08df4b433c404def869f590a15 \
    --hash=sha256:90452ba79b8788fa380dfb587cca692976ef4e757b194b093d845e8d99f612f2 \
    --hash=sha256:928258ba5d6f8ae644e764d0f996d61a8777559f72dfeb2eea7e2fe0ad6e782d \
    --hash=sha256:af03b32695b24d85a75d40e1ba39ffe7db7ffcb099fe507b39fd41a565f1b157 \
    --hash=sha256:b640981bf64a3e978a56167594a0e97db71c89a479da8e175d8bb5be5178c003 \
    --hash=sha256:c5ca78485a255e03c32b513f8c2bc39fedb7f5c5f8535545bdc223a03b24f248 \
    --hash=sha256:c7f3201ec47d5207841402594f1d7950879ef890c0c495052fa62f58283fde1a \
    --hash=sha256:d5ec85080cce7b0513cfd233914eb8b7bbd0633f1d1703aa28d1dd5a72f678ec \
    --hash=sha256:d6c391c021ab1f7a82da5d8d0b3cee2f4b2c455ec86c8aebbc84837a631ff309 \
    --hash=sha256:e3114da6d7f95d2dee7d3f4eec16dacff819740bbab931aff8648cb13c5ff5e7 \
    --hash=sha256:f983596065a18a2183e7f79ab3fd4c475205b839e02cbc0efbbf9666c4b3083d
    # via -r requirements/python3/requirements.in
flask==2.0.3 \
    --hash=sha256:59da8a3170004800a2837844bfa84d49b022550616070f7cb1a659682b2e7c9f \
    --hash=sha256:e1120c228ca2f553b470df4a5fa927ab66258467526069981b3eb0a91902687d
    # via
    #   -r requirements/python3/requirements.in
    #   flask-babel
    #   flask-sqlalchemy
    #   flask-wtf
flask-babel==2.0.0 \
    --hash=sha256:e6820a052a8d344e178cdd36dd4bb8aea09b4bda3d5f9fa9f008df2c7f2f5468 \
    --hash=sha256:f9faf45cdb2e1a32ea2ec14403587d4295108f35017a7821a2b1acb8cfd9257d
    # via -r requirements/python3/requirements.in
flask-sqlalchemy==2.5.1 \
    --hash=sha256:2bda44b43e7cacb15d4e05ff3cc1f8bc97936cc464623424102bfc2c35e95912 \
    --hash=sha256:f12c3d4cc5cc7fdcc148b9527ea05671718c3ea45d50c7e732cceb33f574b390
    # via -r requirements/python3/requirements.in
flask-wtf==1.0.0 \
    --hash=sha256:01feccfc395405cea48a3f36c23f0d766e2cc6fd2a5a065ad50ad3e5827ec797 \
    --hash=sha256:872fbb17b5888bfc734edbdcf45bc08fb365ca39f69d25dc752465a455517b28
    # via -r requirements/python3/requirements.in
itsdangerous==2.0.1 \
    --hash=sha256:5174094b9637652bdb841a3029700391451bd092ba3db90600dea710ba28e97c \
    --hash=sha256:9e724d68fc22902a1435351f84c3fb8623f303fffcc566a4cb952df8c572cff0
    # via
    #   flask
    #   flask-wtf
jinja2==3.1.6 \
    --hash=sha256:0137fb05990d35f1275a587e9aee6d56da821fc83491a0fb838183be43f66d6d \
    --hash=sha256:85ece4451f492d0c13c5dd7c13a64681a86afae63a5f347908daf103ce6d2f67
    # via
    #   -r requirements/python3/requirements.in
    #   flask
    #   flask-babel
mako==1.2.2 \
    --hash=sha256:3724869b363ba630a272a5f89f68c070352137b8fd1757650017b7e06fda163f \
    --hash=sha256:8efcb8004681b5f71d09c983ad5a9e6f5c40601a6ec469148753292abc0da534
    # via alembic
markupsafe==2.1.2 \
    --hash=sha256:0576fe974b40a400449768941d5d0858cc624e3249dfd1e0c33674e5c7ca7aed \
    --hash=sha256:085fd3201e7b12809f9e6e9bc1e5c96a368c8523fad5afb02afe3c051ae4afcc \
    --hash=sha256:090376d812fb6ac5f171e5938e82e7f2d7adc2b629101cec0db8b267815c85e2 \
    --hash=sha256:0b462104ba25f1ac006fdab8b6a01ebbfbce9ed37fd37fd4acd70c67c973e460 \
    --hash=sha256:137678c63c977754abe9086a3ec011e8fd985ab90631145dfb9294ad09c102a7 \
    --hash=sha256:1bea30e9bf331f3fef67e0a3877b2288593c98a21ccb2cf29b74c581a4eb3af0 \
    --hash=sha256:22152d00bf4a9c7c83960521fc558f55a1adbc0631fbb00a9471e097b19d72e1 \
    --hash=sha256:22731d79ed2eb25059ae3df1dfc9cb1546691cc41f4e3130fe6bfbc3ecbbecfa \
    --hash=sha256:2298c859cfc5463f1b64bd55cb3e602528db6fa0f3cfd568d3605c50678f8f03 \
    --hash=sha256:28057e985dace2f478e042eaa15606c7efccb700797660629da387eb289b9323 \
    --hash=sha256:2e7821bffe00aa6bd07a23913b7f4e01328c3d5cc0b40b36c0bd81d362faeb65 \
    --hash=sha256:2ec4f2d48ae59bbb9d1f9d7efb9236ab81429a764dedca114f5fdabbc3788013 \
    --hash=sha256:340bea174e9761308703ae988e982005aedf427de816d1afe98147668cc03036 \
    --hash=sha256:40627dcf047dadb22cd25ea7ecfe9cbf3bbbad0482ee5920b582f3809c97654f \
    --hash=sha256:40dfd3fefbef579ee058f139733ac336312663c6706d1163b82b3003fb1925c4 \

=== ossec/ossec-agent/debian/changelog ===
ossec-agent (3.6.0) unstable; urgency=low

  [ SecureDrop Team ]
  * Release Notes https://github.com/ossec/ossec-hids/releases/tag/3.6.0

 -- SecureDrop Team <securedrop@freedom.press>  Mon, 13 Apr 2020 14:53:21 -0400

ossec-agent (3.0.0) unstable; urgency=low

  [ SecureDrop Team ]
  * Release Notes https://github.com/ossec/ossec-hids/releases/tag/3.0.0

 -- SecureDrop Team <securedrop@freedom.press>  Tue, 21 Aug 2018 10:43:47 -0700

ossec-agent (2.8.2) unstable; urgency=low

  [ SecureDrop Team ]
  * Release Notes https://github.com/ossec/ossec-hids/releases/tag/2.8.2

 -- SecureDrop Team <securedrop@freedom.press>  Thu, 11 Jun 2015 16:43:47 -0700

ossec-agent (2.8.1) unstable; urgency=low

  [ James Dolan ]
  * Initial release

 -- James Dolan <securedrop@pressfreedomfoundation.org>  Fri, 14 Mar 2014 15:46:57 -0700

=== ossec/ossec-server/debian/changelog ===
ossec-server (3.6.0) unstable; urgency=low

  [ SecureDrop Team ]
  * Release Notes https://github.com/ossec/ossec-hids/releases/tag/3.6.0

 -- SecureDrop Team <securedrop@freedom.press>  Mon, 13 Apr 2020 15:22:54 -0400

ossec-server (3.0.0) unstable; urgency=low

  [ SecureDrop Team ]
  * Release Notes https://github.com/ossec/ossec-hids/releases/tag/3.0.0

 -- SecureDrop Team <securedrop@freedom.press>  Tue, 21 Aug 2018 10:43:47 -0700

ossec-server (2.8.2) unstable; urgency=low

  [ SecureDrop Team ]
  * Release Notes https://github.com/ossec/ossec-hids/releases/tag/2.8.2

 -- SecureDrop Team <securedrop@freedom.press>  Thu, 11 Jun 2015 16:43:47 -0700

ossec-server (0.2.1-1) unstable; urgency=low

  * Initial release

 -- James Dolan <securedrop@freedom.press>  Fri, 14 Mar 2014 15:52:47 -0700

=== securedrop/debian/changelog ===
securedrop (2.12.3) unstable; urgency=medium

  * see changelog.md

 -- SecureDrop Team <securedrop@freedom.press>  Fri, 25 Apr 2025 16:20:42 -0400

securedrop (2.12.2) unstable; urgency=medium

  * see changelog.md

 -- SecureDrop Team <securedrop@freedom.press>  Tue, 22 Apr 2025 11:30:35 -0400

securedrop (2.12.1) unstable; urgency=medium

  * see changelog.md

 -- SecureDrop Team <securedrop@freedom.press>  Mon, 31 Mar 2025 11:08:01 -0400

securedrop (2.12.0) unstable; urgency=medium

  * see changelog.md

 -- SecureDrop Team <securedrop@freedom.press>  Tue, 18 Mar 2025 12:02:37 -0400

securedrop (2.11.1) unstable; urgency=medium

  * see changelog.md 

 -- SecureDrop Team <securedrop@freedom.press>  Wed, 18 Dec 2024 17:48:14 -0800

securedrop (2.11.0) unstable; urgency=medium

  * see changelog.md 

 -- SecureDrop Team <securedrop@freedom.press>  Tue, 17 Dec 2024 15:35:07 -0500

securedrop (2.10.1+focal) focal; urgency=medium

  * see changelog.md

 -- SecureDrop Team <securedrop@freedom.press>  Thu, 17 Oct 2024 12:04:45 -0700

securedrop (2.10.0+focal) focal; urgency=medium

  * see changelog.md

 -- SecureDrop Team <securedrop@freedom.press>  Tue, 17 Sep 2024 16:05:58 -0400

securedrop (2.9.0+focal) focal; urgency=medium

  * see changelog.md 

 -- SecureDrop Team <securedrop@freedom.press>  Thu, 27 Jun 2024 13:42:10 -0400

securedrop (2.8.0+focal) focal; urgency=medium

  * see changelog.md 

 -- SecureDrop Team <securedrop@freedom.press>  Tue, 12 Mar 2024 11:01:32 -0400

securedrop (2.7.0+focal) focal; urgency=medium

  * see changelog.md 

 -- SecureDrop Team <securedrop@freedom.press>  Tue, 07 Nov 2023 12:35:26 -0500

securedrop (2.6.1+focal) focal; urgency=medium

  * see changelog.md 

 -- SecureDrop Team <securedrop@freedom.press>  Thu, 17 Aug 2023 10:51:19 -0400

securedrop (2.6.0+focal) focal; urgency=medium

  * see changelog.md 

 -- SecureDrop Team <securedrop@freedom.press>  Thu, 22 Jun 2023 13:35:42 -0400

securedrop-app-code (2.5.2+focal) focal; urgency=medium

  * see changelog.md

 -- SecureDrop Team <securedrop@freedom.press>  Thu, 23 Feb 2023 16:33:50 -0500

securedrop-app-code (2.5.1+focal) focal; urgency=medium

  *

 -- SecureDrop Team <securedrop@freedom.press>  Wed, 19 Oct 2022 16:36:56 -0400

securedrop-app-code (2.5.0+focal) focal; urgency=medium

  * see changelog.md 

 -- SecureDrop Team <securedrop@freedom.press>  Tue, 18 Oct 2022 18:03:53 -0400

securedrop-app-code (2.4.2+focal) focal; urgency=medium

  * see changelog.md

 -- SecureDrop Team <securedrop@freedom.press>  Mon, 08 Aug 2022 21:54:36 -0400

securedrop-app-code (2.4.1+focal) focal; urgency=medium

  * see changelog.md

 -- SecureDrop Team <securedrop@freedom.press>  Wed, 20 Jul 2022 07:25:04 -0400

securedrop-app-code (2.4.0+focal) focal; urgency=medium

  * see changelog.md 

 -- SecureDrop Team <securedrop@freedom.press>  Tue, 24 May 2022 10:51:56 -0400

securedrop-app-code (2.3.2+focal) focal; urgency=medium

  * see changelog.md

 -- SecureDrop Team <securedrop@freedom.press>  Thu, 05 May 2022 14:18:21 -0400

securedrop-app-code (2.3.1+focal) focal; urgency=medium

  * see changelog.md 

 -- SecureDrop Team <securedrop@freedom.press>  Mon, 11 Apr 2022 14:06:51 -0400

securedrop-app-code (2.3.0+focal) focal; urgency=medium

  * see changelog.md

 -- SecureDrop Team <securedrop@freedom.press>  Tue, 29 Mar 2022 19:13:30 -0400

securedrop-app-code (2.2.1+focal) focal; urgency=medium

  * See changelog.md

 -- SecureDrop Team <securedrop@freedom.press>  Thu, 10 Mar 2022 09:34:17 -0800

securedrop-app-code (2.2.0+focal) focal; urgency=medium

  * See changelog.md

 -- SecureDrop Team <securedrop@freedom.press>  Thu, 17 Feb 2022 11:04:38 -0800

securedrop-app-code (2.1.0+focal) focal; urgency=medium

  * see changelog.md 

 -- SecureDrop Team <securedrop@freedom.press>  Tue, 19 Oct 2021 18:20:13 -0400

securedrop-app-code (2.0.2+focal) focal; urgency=medium

  * see changelog.md

 -- SecureDrop Team <securedrop@freedom.press>  Thu, 12 Aug 2021 12:08:35 -0400

securedrop-app-code (2.0.1+focal) focal; urgency=medium

  * see changelog.md 

 -- SecureDrop Team <securedrop@freedom.press>  Thu, 08 Jul 2021 13:32:06 -0400

securedrop-app-code (2.0.0+focal) focal; urgency=medium

  * see changelog.md 

 -- SecureDrop Team <securedrop@freedom.press>  Wed, 23 Jun 2021 16:15:44 -0400

securedrop-app-code (1.8.2+focal) focal; urgency=medium

  * see changelog.md 

 -- SecureDrop Team <securedrop@freedom.press>  Tue, 18 May 2021 20:35:33 +0000

securedrop-app-code (1.8.1+focal) focal; urgency=medium

  * See changelog.md

 -- SecureDrop Team <securedrop@freedom.press>  Wed, 14 Apr 2021 13:32:03 +0000

securedrop-app-code (1.8.0+focal) focal; urgency=medium

  * see changelog.md

 -- SecureDrop Team <securedrop@freedom.press>  Thu, 11 Mar 2021 18:40:32 +0000

=== ossec/ossec-agent/debian/control ===
Source: ossec-agent
Section: web
Priority: optional
Maintainer: SecureDrop Team <securedrop@freedom.press>
Homepage: https://ossec.net
Standards-Version: 4.5.1

Package: ossec-agent
Architecture: amd64
Conflicts: ossec-server
Depends: ${shlibs:Depends}, expect, inotify-tools, adduser
Description: Installs the generic ossec agent

=== ossec/ossec-server/debian/control ===
Source: ossec-server
Section: web
Priority: optional
Maintainer: SecureDrop Team <securedrop@freedom.press>
Homepage: https://ossec.net
Standards-Version: 4.5.1

Package: ossec-server
Architecture: amd64
Conflicts: ossec-agent
Depends: ${shlibs:Depends}, adduser, expect, inotify-tools
Description: Installs generic OSSEC server

=== securedrop/debian/control ===
Source: securedrop
Section: web
Priority: optional
Maintainer: SecureDrop Team <securedrop@freedom.press>
Build-Depends: debhelper (>= 9), dh-python, python3-all, python3-setuptools
Homepage: https://securedrop.org
Standards-Version: 4.5.1

Package: securedrop-app-code
Architecture: amd64
Conflicts: libapache2-mod-wsgi, supervisor
Replaces: libapache2-mod-wsgi, supervisor
Depends: ${dist:Depends}, ${misc:Depends}, ${python3:Depends}, ${apparmor:Depends}, apache2, apparmor-utils, coreutils, gnupg2, libapache2-mod-xsendfile, paxctld, python3, redis-server, securedrop-config, securedrop-keyring, sqlite3
Description: SecureDrop application code, dependencies, Apache configuration, systemd services, and AppArmor profiles. This package will put the AppArmor profiles in enforce mode.

Package: securedrop-config
Architecture: amd64
Depends: ${shlibs:Depends}, ${systemd:Depends}, unattended-upgrades, update-notifier-common
Description: Establishes baseline system state for running SecureDrop.
 Configures apt repositories.

Package: securedrop-keyring
Architecture: all
Depends: gnupg
Description: Provides an apt keyring for SecureDrop-related packages, so the master signing key used for SecureDrop packages can be updated via apt.

Package: securedrop-ossec-agent
Architecture: all
Depends: libevent-2.1-7,libpcre2-8-0,ossec-agent,securedrop-keyring,securedrop-config
Replaces: ossec-agent
Conflicts: securedrop-ossec-server
Description: Installs the securedrop pre-configured OSSEC agent
 This package installs an OSSEC agent pre-configured for the
 SecureDrop app server.

Package: securedrop-ossec-server
Architecture: all
Depends: libevent-2.1-7,libpcre2-8-0,ossec-server,securedrop-keyring,securedrop-config
Replaces: ossec-server
Conflicts: securedrop-ossec-agent
Description: Installs the pre-packaged OSSEC server
 This package installs an OSSEC server pre-configured for the
 SecureDrop mon server. It is configured to email all alerts to
 root@localhost. The SecureDrop ansible playbook will configure
 procmail and postfix to gpg encrypt the OSSEC alerts and email
 them to SecureDrop Admin.

=== ossec/ossec-agent/debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/pkg-info.mk

HUMAN_DATE := $(shell date --utc --date="@${SOURCE_DATE_EPOCH}")

%:
	dh $@

override_dh_install:
	cp debian/preloaded-vars.conf etc/preloaded-vars.conf
	# Disable JIT (TODO, ask upstream to make this configurable)
	sed -i s/USE_PCRE2_JIT=yes/USE_PCRE2_JIT=no/ src/Makefile
	# LDFLAGS overrides warning; see https://github.com/ossec/ossec-hids/issues/2022#issuecomment-982121913
	# (fixed in ossec 3.7.0)
	LDFLAGS="-Wl,-z,muldefs" bash ./install.sh
	# Override date to be reproducible
	sed -i "s/DATE=\".*\"/DATE=\"${HUMAN_DATE}\"/" /var/ossec/etc/ossec-init.conf
	# Use a fixed resolv.conf instead of whatever the container might have from the host
	# TODO: these obviously don't work, what is this file supposed to be used for?
	echo 'nameserver 10.139.1.1\nnameserver 10.139.1.2' > /var/ossec/etc/resolv.conf
	rm /var/ossec/etc/client.keys
	mkdir -p debian/tmp/var/
	cp -Rv /var/ossec debian/tmp/var/
	dh_install

override_dh_fixperms:
	dh_fixperms
	# Fix up permissions to match old packaging
	chmod 440 debian/ossec-agent/var/ossec/etc/*
	chmod 640 debian/ossec-agent/var/ossec/etc/*.conf
	chmod 440 debian/ossec-agent/var/ossec/etc/resolv.conf
	chmod o-r debian/ossec-agent/var/ossec/etc/shared/*.txt
	chmod 550 debian/ossec-agent/var/ossec/active-response/bin/*.sh
	chmod 550 debian/ossec-agent/var/ossec/agentless/*
	chmod 550 debian/ossec-agent/var/ossec/bin/*
	chmod 640 debian/ossec-agent/var/ossec/logs/ossec.log

=== ossec/ossec-server/debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/pkg-info.mk

HUMAN_DATE := $(shell date --utc --date="@${SOURCE_DATE_EPOCH}")

%:
	dh $@

override_dh_install:
	cp debian/preloaded-vars.conf etc/preloaded-vars.conf
	# Disable JIT (TODO, ask upstream to make this configurable)
	sed -i s/USE_PCRE2_JIT=yes/USE_PCRE2_JIT=no/ src/Makefile
	# LDFLAGS overrides warning; see https://github.com/ossec/ossec-hids/issues/2022#issuecomment-982121913
	# (fixed in ossec 3.7.0)
	LDFLAGS="-Wl,-z,muldefs" bash ./install.sh
	# Override date to be reproducible
	sed -i "s/DATE=\".*\"/DATE=\"${HUMAN_DATE}\"/" /var/ossec/etc/ossec-init.conf
	# Override hostname to be reproducible
	sed -i "s/<email_from>ossecm@.*<\/email_from>/<email_from>ossecm@sd-ossec-builder<\/email_from>/" /var/ossec/etc/ossec.conf
	# Use a fixed resolv.conf instead of whatever the container might have from the host
	# TODO: these obviously don't work, what is this file supposed to be used for?
	echo 'nameserver 10.139.1.1\nnameserver 10.139.1.2' > /var/ossec/etc/resolv.conf
	rm /var/ossec/etc/client.keys
	mkdir -p debian/tmp/var/
	cp -Rv /var/ossec debian/tmp/var/
	dh_install

override_dh_fixperms:
	dh_fixperms
	# Fix up permissions to match old packaging
	chmod 640 debian/ossec-server/var/ossec/rules/*.xml
	chmod 640 debian/ossec-server/var/ossec/etc/*
	chmod 440 debian/ossec-server/var/ossec/etc/localtime
	chmod 440 debian/ossec-server/var/ossec/etc/resolv.conf
	chmod 640 debian/ossec-server/var/ossec/etc/shared/*.txt
	chmod 550 debian/ossec-server/var/ossec/bin/*
	chmod 550 debian/ossec-server/var/ossec/agentless/*
	chmod 550 debian/ossec-server/var/ossec/active-response/bin/*.sh
	chmod 640 debian/ossec-server/var/ossec/logs/*

=== securedrop/debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/pkg-info.mk

DEB_DH_INSTALL_ARGS=-X .git
PIP_ARGS=--verbose --no-deps --no-binary=:all: --no-cache-dir

%:
	dh $@ --with systemd --buildsystem=pybuild

# Move the conffile in version control to squash the autogenerated one
# by debhelper, as files in /etc/ are automatically marked as
# conffiles.  We are shipping AppArmor profiles via this package, and
# want them to be correctly updated with each update.
override_dh_installdeb:
	dh_installdeb
	echo -n "" > ${CURDIR}/debian/securedrop-app-code/DEBIAN/conffiles
	echo -n "" > ${CURDIR}/debian/securedrop-config/DEBIAN/conffiles
	echo -n "" > ${CURDIR}/debian/securedrop-keyring/DEBIAN/conffiles

override_dh_auto_install:
	# Build securedrop-config Rust code
	cd /srv/rust/noble-migration && cargo build --release --locked && \
		cd /srv/securedrop && \
		mkdir -p ./debian/securedrop-config/usr/bin && \
		mv /srv/rust/target/release/check ./debian/securedrop-config/usr/bin/securedrop-noble-migration-check && \
		mv /srv/rust/target/release/upgrade ./debian/securedrop-config/usr/bin/securedrop-noble-migration-upgrade
	# Build redwood wheel
	python3 /srv/rust/redwood/build-wheel.py --release --redwood /srv/rust/redwood --target /srv/rust/target
	# Set up virtualenv and install dependencies
	/usr/bin/python3 -m venv ./debian/securedrop-app-code/opt/venvs/securedrop-app-code
	./debian/securedrop-app-code/opt/venvs/securedrop-app-code/bin/pip install $(PIP_ARGS) \
		pip==25.0
	./debian/securedrop-app-code/opt/venvs/securedrop-app-code/bin/pip install $(PIP_ARGS) \
		-r requirements/python3/requirements.txt
	./debian/securedrop-app-code/opt/venvs/securedrop-app-code/bin/pip install $(PIP_ARGS) \
		/srv/rust/redwood/redwood-*.whl
	# Update paths to point to install destination
	find ./debian/securedrop-app-code/ -type f -exec sed -i "s#$(shell pwd)/debian/securedrop-app-code##" {} \;
	# Generage wsgi.load for apache
	mkdir -p ./debian/securedrop-app-code/etc/apache2/mods-available
	python3 ./debian/gen-mods.py > ./debian/securedrop-app-code/etc/apache2/mods-available/wsgi.load
	dh_auto_install $@

override_dh_auto_test:
	# Skip, we don't run tests at package build time

override_dh_install:
	# Build translations
	bash ./debian/translations.sh
	# Things to exclude
	find . -type f -name '*requirements.in' -delete
	find . -type f -name '*.mako' -delete
	rm upload-screenshots.py
	# If a custom logo exists in the tree, delete it
	rm -f static/i/custom_logo.png
	# Same with any config.py
	rm -f config.py
	dh_install

override_dh_strip_nondeterminism:
	# Delete non-reproducible things
	find ./debian/ -type f -name '*.pyc' -delete
	find ./debian/ -type f -name 'pip-selfcheck.json' -delete
	find ./debian/ -type f -name 'RECORD' -delete
	dh_strip_nondeterminism $@

override_dh_gencontrol:
ifneq ($(findstring +noble,$(DEB_VERSION)),)
	dh_gencontrol -psecuredrop-app-code -- "-Vapparmor:Depends=apparmor (>= 4.0.1really4.0.1-0ubuntu0.24.04.3)"
	dh_gencontrol -psecuredrop-config -- "-Vsystemd:Depends=systemd-hwe-hwdb"
else
	dh_gencontrol -psecuredrop-app-code -- "-Vapparmor:Depends="
	dh_gencontrol -psecuredrop-config -- "-Vsystemd:Depends="
endif
	dh_gencontrol -psecuredrop-ossec-agent -- "-v3.6.0+${DEB_VERSION}"
	dh_gencontrol -psecuredrop-ossec-server -- "-v3.6.0+${DEB_VERSION}"
	dh_gencontrol -psecuredrop-keyring -- "-v0.2.2+${DEB_VERSION}"
	dh_gencontrol --remaining-packages

#
# Have to override the automatic service handling since we have more
# than one.
#
override_dh_installinit:
	dh_installinit --noscripts

# We want to enable all systemd units except those that are run by timers, so
# we have to mark those as --no-enable first, then the final
# `dh_systemd_enable` invocation will enable the rest.
override_dh_systemd_enable:
	dh_systemd_enable --no-enable securedrop-submissions-today.service
	dh_systemd_enable --no-enable securedrop-clean-tmp.service
	dh_systemd_enable --no-enable securedrop-remove-pending-sources.service
	dh_systemd_enable --no-enable securedrop-remove-packages.service
	dh_systemd_enable --no-enable securedrop-cleanup-ossec.service
	dh_systemd_enable --no-enable securedrop-reboot-required.service
	dh_systemd_enable --no-enable securedrop-noble-migration-check.service
	dh_systemd_enable --no-enable securedrop-noble-migration-upgrade.service
	dh_systemd_enable

# This is basically the same as the enable stanza above, just whether the
# unit should be started after installation.
override_dh_systemd_start:
	dh_systemd_start --no-start securedrop-submissions-today.service
	dh_systemd_start --no-start securedrop-clean-tmp.service
	dh_systemd_start --no-start securedrop-remove-pending-sources.service
	dh_systemd_start --no-start securedrop-remove-packages.service
	dh_systemd_start --no-start securedrop-cleanup-ossec.service
	dh_systemd_start --no-start securedrop-reboot-required.service
	dh_systemd_start --no-start securedrop-noble-migration-check.service
	dh_systemd_start --no-start --no-restart-after-upgrade \
		securedrop-noble-migration-upgrade.service
	dh_systemd_start
